{Autor: Piotr Sokolowski,kwiecien 1998r}
{$g+} {instrukcje 286}
uses crt;
const
xv = 0; {wspolrzedne obserwatora}
yv = 150;
zv = 330;
przesuniecie_x = 100; {parametry pozwalajace na przesow obracanej figury
                      niezaleznie od jej wspolrzednych }
przesuniecie_y = 60;
type wspol_z = record
z:real;
nr:integer;
end;
type sciana = record
xxx1,yyy1,zzz1,xxx2,yyy2,zzz2,xxx3,yyy3,zzz3:real;
end;
var
kat:real;
sciany:array[1..40] of sciana;
nr_,ile_scian:integer;
wspolrzedne_z:array[1..50] of wspol_z;
Procedure TriAngle(X1,Y1,X2,Y2,X3,Y3:Integer; Color:Byte); Assembler;
Var RV1,RV2,IF1,IF2,DeX1,DeX2,DeY1,DeY2 : Integer;
{**** Procedura rysujaca wypelniony trojkat - wzieta z biblioteki SWAG****}
Asm

  CLI

  {Sort by Y-value}
  Mov  CX,2
@@SortLoop:
  Mov  AX,[Y2]; Cmp  AX,[Y3]; JBE  @@Skip1
  Xor  AX,[Y3]; Xor  [Y3],AX; Xor  AX,[Y3]; Mov  [Y2],AX
  Mov  AX,[X2]; Xor  AX,[X3]; Xor  [X3],AX; Xor  AX,[X3]; Mov  [X2],AX
@@Skip1:
  Mov  AX,[Y1]; Cmp  AX,[Y2]; JBE  @@Skip2
  Xor  AX,[Y2]; Xor  [Y2],AX; Xor  AX,[Y2]; Mov  [Y1],AX
  Mov  AX,[X1]; Xor  AX,[X2]; Xor  [X2],AX; Xor  AX,[X2]; Mov  [X1],AX
@@Skip2:
  Mov  AX,[Y1]; Cmp  AX,[Y3]; JBE  @@Skip3
  Xor  AX,[Y3]; Xor  [Y3],AX; Xor  AX,[Y3]; Mov  [Y1],AX
  Mov  AX,[X1]; Xor  AX,[X3]; Xor  [X3],AX; Xor  AX,[X3]; Mov  [X1],AX
@@Skip3:
  Loop @@SortLoop

  {Calculate start-offsets}
  Mov  DX,[Y1]; Shl  DX,6; Mov  BX,DX; Shl  DX,2; Add  DX,BX
  Add  DX,[X1]; Mov  SI,DX

  {Claculate DY, and fill DeY en RefVar with it}
  {Just sorted by Y-value, so no checking for <0 is needed}
  Mov  AX,[Y3]; Sub  AX,[Y1]; Inc  AX; Mov  [DeY1],AX
  Mov  [RV1],AX; Mov  AX,[Y2]; Sub  AX,[Y1]; Inc  AX
  Mov  [DeY2],AX; Mov  [RV2],AX

  {Same for DX. Possible to get a <0 value, so check for that}
  Mov  [IF1],1; Mov  AX,[X3]; Sub  AX,[X1]; JNC  @@SkipDXNeg1
  Neg  AX; Neg  [IF1]
@@SkipDXNeg1:
  Inc  AX; Mov  [DeX1],AX; Mov  [IF2],1; Mov  AX,[X2]
  Sub  AX,[X1]; JNC  @@SkipDXNeg2; Neg  AX; Neg  [IF2]
@@SkipDXNeg2:
  Inc  AX; Mov  [DeX2],AX

  {Video segment in ES}
  Mov  AX,$A000; Mov  ES,AX

  Mov  AL,[Color]; Mov  AH,AL; Mov  CX,[DeY2]
@@DrawLoop1:
  Push CX
  {Draw a horizontal line}
  Mov  DI,DX
  Mov  CX,SI
  Cmp  CX,DI
  JA   @@DontSwap1
  Xchg CX,DI
@@DontSwap1:
  Sub  CX,DI
  Inc  CX
  Test CX,1
  JZ   @@Even1
  StosB
@@Even1:
  Shr  CX,1
  Rep  StosW

  {Adapt: RV1, Ofs1}
  Mov  BX,[RV1]
  Sub  BX,[DeX1]
  Cmp  BX,0
  JG   @@DoNothing1
@@DoSomething1:
  Add  BX,[DeY1]
  Add  DX,[IF1]
  Cmp  BX,0
  JLE  @@DoSomething1
@@DoNothing1:
  Add  DX,320
  Mov  [RV1],BX

  {Adapt: RV2, Ofs2}
  Mov  BX,[RV2]
  Sub  BX,[DeX2]
  Cmp  BX,0
  JG   @@DoNothing2
@@DoSomething2:
  Add  BX,[DeY2]
  Add  SI,[IF2]
  Cmp  BX,0
  JLE  @@DoSomething2
@@DoNothing2:
  Add  SI,320
  Mov  [RV2],BX

  Pop  CX
  Loop @@DrawLoop1

  {Adapt: DeY2, DeX2, RV2, IF2}
  Push DX
  Mov  DX,[Y3]
  Sub  DX,[Y2]
  Inc  DX
  Mov  [DeY2],DX
  Mov  [RV2],DX
  Mov  [IF2],1
  Mov  DX,[X3]
  Sub  DX,[X2]
  JNC  @@DX2Pos
  Neg  DX
  Neg  [IF2]
@@DX2Pos:
  Inc  DX
  Mov  [DeX2],DX
  Pop  DX

  {Draw second half of poly}
  Mov  CX,[DeY2]
@@DrawLoop2:
  Push CX
  {Draw a horizontal line}
  Mov  DI,DX
  Mov  CX,SI
  Cmp  CX,DI
  JA   @@DontSwap2
  Xchg CX,DI
@@DontSwap2:
  Sub  CX,DI
  Inc  CX
  Test CX,1
  JZ   @@Even2
  StosB
@@Even2:
  Shr  CX,1
  Rep  StosW

  {Adapt: RV1, Ofs1}
  Mov  BX,[RV1]
  Sub  BX,[DeX1]
  Cmp  BX,0
  JG   @@DoNothing3
@@DoSomething3:
  Add  BX,[DeY1]
  Add  DX,[IF1]
  Cmp  BX,0
  JLE  @@DoSomething3
@@DoNothing3:
  Add  DX,320
  Mov  [RV1],BX

  {Adapt: RV2, Ofs2}
  Mov  BX,[RV2]
  Sub  BX,[DeX2]
  Cmp  BX,0
  JG   @@DoNothing4
@@DoSomething4:
  Add  BX,[DeY2]
  Add  SI,[IF2]
  Cmp  BX,0
  JLE  @@DoSomething4
@@DoNothing4:
  Add  SI,320
  Mov  [RV2],BX

  Pop  CX
  Loop @@DrawLoop2
@@Exit:
  STI
End;
procedure obroc_X;{przeliczenia dla obrotu - obrot wokol osi X}
var
xx,yy,zz,x,y,z:real;
nr:integer;
begin
nr:=0;
repeat
nr:=nr+1;
x:=sciany[nr].xxx1;
y:=sciany[nr].yyy1;
z:=sciany[nr].zzz1;

xx:=x;
yy:=y*cos(-kat)+z*sin(-kat);
zz:=z*cos(-kat)-y*sin(-kat);

sciany[nr].xxx1:=xx;
sciany[nr].yyy1:=yy;
sciany[nr].zzz1:=zz;

x:=sciany[nr].xxx2;
y:=sciany[nr].yyy2;
z:=sciany[nr].zzz2;

xx:=x;
yy:=y*cos(-kat)+z*sin(-kat);
zz:=z*cos(-kat)-y*sin(-kat);

sciany[nr].xxx2:=xx;
sciany[nr].zzz2:=zz;
sciany[nr].yyy2:=yy;

x:=sciany[nr].xxx3;
y:=sciany[nr].yyy3;
z:=sciany[nr].zzz3;

xx:=x;
yy:=y*cos(-kat)+z*sin(-kat);
zz:=z*cos(-kat)-y*sin(-kat);

sciany[nr].xxx3:=xx;
sciany[nr].yyy3:=yy;
sciany[nr].zzz3:=zz;

until nr = ile_scian;
end;

procedure obroc_z;{przeliczenia dla obrotu - obrot wokol osi Z}
var
xx,yy,zz,x,y,z:real;
nr:integer;
begin
nr:=0;
repeat
nr:=nr+1;
x:=sciany[nr].xxx1;
y:=sciany[nr].yyy1;
z:=sciany[nr].zzz1;

xx:=x*cos(kat)+y*sin(kat);
yy:=y*cos(kat)-x*sin(kat);
zz:=z;

sciany[nr].xxx1:=xx;
sciany[nr].yyy1:=yy;
sciany[nr].zzz1:=zz;

x:=sciany[nr].xxx2;
y:=sciany[nr].yyy2;
z:=sciany[nr].zzz2;

yy:=y;
xx:=x*cos(kat)+y*sin(kat);
yy:=y*cos(kat)-x*sin(kat);
zz:=z;

sciany[nr].xxx2:=xx;
sciany[nr].zzz2:=zz;
sciany[nr].yyy2:=yy;

x:=sciany[nr].xxx3;
y:=sciany[nr].yyy3;
z:=sciany[nr].zzz3;
yy:=y;

xx:=x*cos(kat)+y*sin(kat);
yy:=y*cos(kat)-x*sin(kat);
zz:=z;

sciany[nr].xxx3:=xx;
sciany[nr].yyy3:=yy;
sciany[nr].zzz3:=zz;

until nr = ile_scian;
end;



procedure obroc_y;{przeliczenia dla obrotu - obrot wokol osi Y}
var
xx,yy,zz,x,y,z:real;
nr:integer;
begin
nr:=0;
repeat
nr:=nr+1;
x:=sciany[nr].xxx1;
y:=sciany[nr].yyy1;
z:=sciany[nr].zzz1;

xx:=x*cos(-kat)-z*sin(-kat);
zz:=z*cos(-kat)+x*sin(-kat);
yy:=y;

sciany[nr].xxx1:=xx;
sciany[nr].yyy1:=yy;
sciany[nr].zzz1:=zz;

x:=sciany[nr].xxx2;
y:=sciany[nr].yyy2;
z:=sciany[nr].zzz2;

yy:=y;
xx:=x*cos(-kat)-z*sin(-kat);
zz:=z*cos(-kat)+x*sin(-kat);

sciany[nr].xxx2:=xx;
sciany[nr].zzz2:=zz;
sciany[nr].yyy2:=yy;

x:=sciany[nr].xxx3;
y:=sciany[nr].yyy3;
z:=sciany[nr].zzz3;
yy:=y;

xx:=x*cos(-kat)-z*sin(-kat);
zz:=z*cos(-kat)+x*sin(-kat);

sciany[nr].xxx3:=xx;
sciany[nr].yyy3:=yy;
sciany[nr].zzz3:=zz;

until nr = ile_scian;
end;


procedure sciana_3d_to_2d(x1_,y1_,z1_,x2_,y2_,z2_,x3_,y3_,z3_:real;color:integer);
{procedura wyswietlajaca trojkat 3D na ekranie w 2D, o danym kolorze-
posrednik w stosunku do procedury TriAngle}
var
xx1,yy1,xx2,yy2,xx3,yy3,xx4,yy4:real;
begin
xx1:=przesuniecie_X+320-(xv+(xv - x1_)*zv/(z1_ - zv));
yy1:=przesuniecie_y+240-(yv+(yv - y1_)*zv/(z1_ - zv));

xx2:=przesuniecie_X+320-(xv+(xv - x2_)*zv/(z2_ - zv));
yy2:=przesuniecie_y+240-(yv+(yv - y2_)*zv/(z2_ - zv));

xx3:=przesuniecie_X+320-(xv+(xv - x3_)*zv/(z3_ - zv));
yy3:=przesuniecie_y+240-(yv+(yv - y3_)*zv/(z3_ - zv));
TriAngle(round(xx1),round(yy1),round(xx2),round(yy2),round(xx3),round(yy3),color);
end;
procedure wyswietl_sciany;
var
nr,nr1,nr2:byte;
suma_z:real;
bufor1,bufor2:real;
l,l1,l2:byte;
begin
{sumowanie wspolrzednych Z trojkatow i zapis wynikow do tablicy}
nr:=0;
repeat
inc(nr);
suma_z:=sciany[nr].zzz1+sciany[nr].zzz2+sciany[nr].zzz3;
wspolrzedne_z[nr].z:=suma_z;
wspolrzedne_z[nr].nr:=nr;
until nr = ile_scian;
{porzadkowanie trojkatow wedlug wspolrzednej Z}
l:=1;
l1:=1;
l2:=2;
repeat
if (wspolrzedne_z[l2].z < wspolrzedne_z[l1].z)then
begin
bufor1:=wspolrzedne_z[l1].z;
nr1:=wspolrzedne_z[l1].nr;
bufor2:=wspolrzedne_z[l2].z;
nr2:=wspolrzedne_z[l2].nr;
wspolrzedne_z[l2].z:=bufor1;
wspolrzedne_z[l2].nr:=nr1;
{poprostu zamiana miejscamy gdy warunek(..>..) spelniony}
wspolrzedne_z[l1].z :=bufor2;
wspolrzedne_z[l1].nr:=nr2;
end;


inc(l1);
inc(l2);

if l2 = ile_scian+1 then

begin
l1:=1;
l2:=2;
inc(l);
end;
until l = ile_scian+1;

{wyswietlenie zgodnie z wczesniej wyznaczona kolejnoscia}
nr:=0;
repeat
inc(nr);
sciana_3d_to_2d(sciany[wspolrzedne_z[nr].nr].xxx1,sciany[wspolrzedne_z[nr].nr].yyy1,sciany[wspolrzedne_z[nr].nr].zzz1,
sciany[wspolrzedne_z[nr].nr].xxx2,sciany[wspolrzedne_z[nr].nr].yyy2,sciany[wspolrzedne_z[nr].nr].zzz2,
sciany[wspolrzedne_z[nr].nr].xxx3,sciany[wspolrzedne_z[nr].nr].yyy3,sciany[wspolrzedne_z[nr].nr].zzz3,
wspolrzedne_z[nr].nr);
until nr = ile_scian;
end;
procedure zgas_sciany;
var
nr:byte;
begin
nr:=0;
repeat
inc(nr);
sciana_3d_to_2d(sciany[nr].xxx1,sciany[nr].yyy1,sciany[nr].zzz1,
sciany[nr].xxx2,sciany[nr].yyy2,sciany[nr].zzz2, sciany[nr].xxx3,sciany[nr].yyy3,sciany[nr].zzz3,0);
until nr = ile_scian;
end;
{---poczatek programu glownego---}
begin
asm     {przejscie do trybu 13h - 320x200 przy 256 kolorach}
mov ax,13h
int 10h
end;
gotoxy(1,1);
sciany[1].xxx1:=-30; {poczatkowe wspolrzedne szescianu}
sciany[1].yyy1:=30;
sciany[1].zzz1:=30;

sciany[1].xxx2:=30;
sciany[1].yyy2:=30;
sciany[1].zzz2:=30;

sciany[1].xxx3:=-30;
sciany[1].yyy3:=-30;
sciany[1].zzz3:=30;

sciany[2].xxx1:=-30;
sciany[2].yyy1:=-30;
sciany[2].zzz1:=30;


sciany[2].xxx2:=30;
sciany[2].yyy2:=-30;
sciany[2].zzz2:=30;

sciany[2].xxx3:=30;
sciany[2].yyy3:=30;
sciany[2].zzz3:=30;

sciany[3].xxx1:=-30;
sciany[3].yyy1:=-30;
sciany[3].zzz1:=30;


sciany[3].xxx2:=-30;
sciany[3].yyy2:=-30;
sciany[3].zzz2:=-30;

sciany[3].xxx3:=30;
sciany[3].yyy3:=-30;
sciany[3].zzz3:=-30;


sciany[4].xxx1:=-30;
sciany[4].yyy1:=-30;
sciany[4].zzz1:=30;


sciany[4].xxx2:=30;
sciany[4].yyy2:=-30;
sciany[4].zzz2:=-30;

sciany[4].xxx3:=30;
sciany[4].yyy3:=-30;
sciany[4].zzz3:=30;

sciany[5].xxx1:=-30;
sciany[5].yyy1:=-30;
sciany[5].zzz1:=-30;


sciany[5].xxx2:=-30;
sciany[5].yyy2:=30;
sciany[5].zzz2:=-30;

sciany[5].xxx3:=30;
sciany[5].yyy3:=-30;
sciany[5].zzz3:=-30;

sciany[6].xxx1:=-30;
sciany[6].yyy1:=30;
sciany[6].zzz1:=-30;


sciany[6].xxx2:=30;
sciany[6].yyy2:=30;
sciany[6].zzz2:=-30;

sciany[6].xxx3:=30;
sciany[6].yyy3:=-30;
sciany[6].zzz3:=-30;

sciany[8].xxx1:=30;
sciany[8].yyy1:=-30;
sciany[8].zzz1:=30;


sciany[8].xxx2:=30;
sciany[8].yyy2:=-30;
sciany[8].zzz2:=-30;

sciany[8].xxx3:=30;
sciany[8].yyy3:=30;
sciany[8].zzz3:=30;

sciany[7].xxx1:=30;
sciany[7].yyy1:=30;
sciany[7].zzz1:=30;


sciany[7].xxx2:=30;
sciany[7].yyy2:=30;
sciany[7].zzz2:=-30;

sciany[7].xxx3:=30;
sciany[7].yyy3:=-30;
sciany[7].zzz3:=-30;

sciany[9].xxx1:=-30;
sciany[9].yyy1:=30;
sciany[9].zzz1:=30;


sciany[9].xxx2:=-30;
sciany[9].yyy2:=30;
sciany[9].zzz2:=-30;

sciany[9].xxx3:=30;
sciany[9].yyy3:=30;
sciany[9].zzz3:=30;


sciany[10].xxx1:=30;
sciany[10].yyy1:=30;
sciany[10].zzz1:=30;


sciany[10].xxx2:=30;
sciany[10].yyy2:=30;
sciany[10].zzz2:=-30;

sciany[10].xxx3:=-30;
sciany[10].yyy3:=30;
sciany[10].zzz3:=-30;

sciany[11].xxx1:=-30;
sciany[11].yyy1:=-30;
sciany[11].zzz1:=-30;


sciany[11].xxx2:=-30;
sciany[11].yyy2:=-30;
sciany[11].zzz2:=30;

sciany[11].xxx3:=-30;
sciany[11].yyy3:=30;
sciany[11].zzz3:=30;

sciany[12].xxx1:=-30;
sciany[12].yyy1:=-30;
sciany[12].zzz1:=-30;


sciany[12].xxx2:=-30;
sciany[12].yyy2:=30;
sciany[12].zzz2:=-30;

sciany[12].xxx3:=-30;
sciany[12].yyy3:=30;
sciany[12].zzz3:=30;


ile_scian:=10;
kat:=pi/35; {kat o jaki obracamy}
repeat
wyswietl_sciany;
delay(300); {**szybkosc animacji**}
repeat until  (port[$03da] and 8)=0;
repeat until  (port[$03da] and 8)=8;
zgas_sciany;
obroc_x;
obroc_y;
obroc_z;
until keypressed;
asm       {powrot do trybu tekstowego}
mov ax,03h
int 10h
end;
writeln('Autor: Piotr Sokolowski ,kwiecien 1998r');
end.