{Prosty program obrazujacy wykorzystanie informacji z pliku 3d_2d.txt}
                   {=========================}
                   {=Autor: Piotr Sokolowski=}
                   {=========================}
{Uwaga: Bledy obliczen prowadza do tego ze po pewnym czasie figura sie
znieksztalca}
Uses crt,graph;
const
obserw = -1300;
type
wiechrz = record
x,y,z:integer;
end;
type
wspol = record
x,y:integer;
end;
var
kl:char;
z_obs,x_obs,y_obs:integer;
kat:real;
i, code: Integer;
ktory:integer;
ciag:string;
licznik:integer;
bok:integer;
graf1,graf2:integer;
wierzcholki:array[1..8] of wiechrz;
obraz:array[1..8] of wspol;
procedure obroc;  {przeliczenia dla obrotu}
var
nr,xx,yy,zz,x,y,z:integer;
begin
nr:=0;
repeat
inc(nr);
x:=wierzcholki[nr].x;
z:=wierzcholki[nr].z;
xx:=round(z*sin(kat)+x*cos(kat));
zz:=round(z*cos(kat)-x*sin(kat));
wierzcholki[nr].x:=xx;
wierzcholki[nr].z:=zz;
until nr = 8;
end;
procedure obroc_2;{przeliczenia dla obrotu}
var
nr,xx,yy,zz,x,y,z:integer;

begin
nr:=0;
repeat
inc(nr);
x:=wierzcholki[nr].x;
y:=wierzcholki[nr].y;
xx:=round(x*cos(kat)+y*sin(kat));
yy:=round(-x*sin(kat)+y*cos(kat));
wierzcholki[nr].x:=xx;
wierzcholki[nr].y:=yy;
until nr = 8;
end;
procedure rysuj;{rysowanie wszystkich lini}
begin
line(obraz[4].x,obraz[4].y,obraz[8].x,obraz[8].y);
line(obraz[4].x,obraz[4].y,obraz[3].x,obraz[3].y);
line(obraz[8].x,obraz[8].y,obraz[7].x,obraz[7].y);
line(obraz[8].x,obraz[8].y,obraz[5].x,obraz[5].y);
line(obraz[6].x,obraz[6].y,obraz[5].x,obraz[5].y);
line(obraz[6].x,obraz[6].y,obraz[7].x,obraz[7].y);
line(obraz[5].x,obraz[5].y,obraz[1].x,obraz[1].y);
line(obraz[2].x,obraz[2].y,obraz[6].x,obraz[6].y);
line(obraz[3].x,obraz[3].y,obraz[7].x,obraz[7].y);
line(obraz[3].x,obraz[3].y,obraz[2].x,obraz[2].y);
line(obraz[4].x,obraz[4].y,obraz[1].x,obraz[1].y);
line(obraz[2].x,obraz[2].y,obraz[1].x,obraz[1].y);
end;
procedure rzutuj;{przeliczenie wspolrzednych punktu na wspolrzedne ekranu}
var
nr,xx,yy,x,y,z:integer;
begin
nr:=0;
repeat
inc(nr);
x:=wierzcholki[nr].x+x_obs;
y:=wierzcholki[nr].y+y_obs;
z:=wierzcholki[nr].z+z_obs;
xx:=round(x*(-obserw / (z-obserw)));
yy:=round(y*(-obserw / (z-obserw)));
obraz[nr].x := xx+340;
obraz[nr].y := yy+240;
until nr = 8;
end;
begin
graf1:=detect;
initgraph(graf1,graf2,'');
bok:=getmaxx div 3;
x_obs:=0;
y_obs:=0;
z_obs:=0;
{wartosci poczatkowe wierzcholkow - szescian}
wierzcholki[1].x := 0;
wierzcholki[1].y := 0;
wierzcholki[1].z := 0;

wierzcholki[2].x := bok;
wierzcholki[2].y := 0;
wierzcholki[2].z := 0;

wierzcholki[3].x := bok;
wierzcholki[3].y := 0;
wierzcholki[3].z := bok;

wierzcholki[4].x := 0;
wierzcholki[4].y := 0;
wierzcholki[4].z := bok;

wierzcholki[5].x := 0;
wierzcholki[5].y := bok;
wierzcholki[5].z := 0;

wierzcholki[6].x := bok;
wierzcholki[6].y := bok;
wierzcholki[6].z := 0;

wierzcholki[7].x := bok;
wierzcholki[7].y := bok;
wierzcholki[7].z := bok;

wierzcholki[8].x := 0;
wierzcholki[8].y := bok;
wierzcholki[8].z := bok;

kat:= Pi / 35;
repeat
obroc;
rzutuj;
setcolor(2);
rysuj;
delay(300);      {opoznienie animacji, 300 dla 586}
setcolor(0);
rysuj;
obroc_2;
rzutuj;
setcolor(2);
rysuj;
delay(300);      {opoznienie animacji, 300 dla 586}
setcolor(0);
rysuj;
if keypressed then
begin
kl:=readkey;
if kl = chr(13) then inc(z_obs,50);
if kl = chr(32) then dec(z_obs,50);
end;
until kl = chr(27);;
kl:=chr(0);
end.
{Animacja tworzona jest poprzez gaszenie w starych wspolrzednych figury i
zapalaniu jej w nowych(po przeliczeniach obrotu),gdzie:
gaszenie - rysowanie kolorem tla(tu 0 - czarny)
zapalanie - rysowanie kolorem roznym od tla}