{Autor: Piotr Sokolowski, 1997r}
uses crt;
type
copy_dane = record
bllength:longint;{********* Dlugosc musi byc liczba parzysta ***********}
srchandle:word;
srcoffset:longint;
dsthandle:word;
dstoffset:longint;
end;
var
adres_logiczny:longint;
adres_funkcji_sterujacej:pointer; {znaczenie patrz nazwa zmiennej}
bufor:array[1..32000] of byte; {**** BUFOR NA PRZESYLANE DANE ****}
dane:copy_dane;
blad:byte;
wielkosc:word;
dojscie_xms:word;
xms_wersja_xms_1:word;
xms_wersja_xms_2:word;
wolna_pamiec_xms:word;
procedure oczysc_bufor;{*** OPERACJA KONIECZNA ***}
var
licz__:word;
begin
for licz__:=1 to 32000 do
begin
bufor[licz__]:=0;
end;

end;
function xms_obecnosc:string;
var
bajt:byte;
begin
asm
mov ax,4300h
int 2Fh
mov bajt,al
end;
if bajt = 128 then xms_obecnosc:='TAK';
if bajt <> 128 then xms_obecnosc:='NIE';
end;

procedure xms_adres_funkcji_sterujacej;
var
slowo_es,slowo_bx:word;
begin
asm
mov ax,4310h
int 2Fh
mov ax,es
mov slowo_es,ax
mov slowo_bx,bx
end;
adres_funkcji_sterujacej:=ptr(slowo_es,slowo_bx);
end;
procedure sprawdz_blad;
begin
case blad of
$00:begin
{OK}
end;
$80:writeln('Bledny numer funkcji');
$A0:writeln('Brak wystarczajacej dostepnej pamieci XMS');
$A1:writeln('Brak wolnego dojscia');
$A2:writeln('Bledne dojscie');
$A3:writeln('Bledne dojscie zrodlowe');
$A4:writeln('Za duzy offset zrodlowy');
$A5:writeln('Bledne dojscie docelowe');
$A6:writeln('Za duzy offset docelowy');
$A7:writeln('Za duza dlugosc przesylanego bloku');
$A8:writeln('Obszar zrodlowy i docelowy bloku EMB zachodza na siebie');
$A9:writeln('Sprzetowy blad parzystosci');
$AB:writeln('Blok jest zablokowany');
end;
end;
procedure xms_odczytaj_wersje_xms;
var
slowo_1:word;
slowo_2:word;
begin
asm
mov ax,seg adres_funkcji_sterujacej
mov es,ax
mov bx,offset adres_funkcji_sterujacej
mov ax,0h
call dword ptr es:[bx]
mov slowo_1,ax
mov slowo_2,bx
end;
xms_wersja_xms_1:=slowo_1;
xms_wersja_xms_2:=slowo_2;
end;

function xms_wolna_pamiec_xms:word;
var
slowo:word;
begin
asm
mov ax,seg adres_funkcji_sterujacej
mov es,ax
mov bx,offset adres_funkcji_sterujacej
mov ax,800h
call dword ptr es:[bx]
mov slowo,dx
end;
xms_wolna_pamiec_xms:=slowo;
end;

function xms_najwiekszy_wolny_blok_emb:word;
var
slowo:word;
begin
asm
mov ax,seg adres_funkcji_sterujacej
mov es,ax
mov bx,offset adres_funkcji_sterujacej
mov ax,800h
call dword ptr es:[bx]
mov slowo,ax
end;
xms_najwiekszy_wolny_blok_emb:=slowo;
end;



procedure xms_pisz_wersje_xms_1;
var
bajt_1,bajt_2:byte;
begin
asm
mov ax,word ptr ds:[xms_wersja_xms_1]
mov bajt_1,ah
mov bajt_2,al
end;
write(bajt_1,'.',bajt_2);
end;

procedure xms_pisz_wersje_xms_2;
var
bajt_1,bajt_2:byte;
begin
asm
mov ax,word ptr ds:[xms_wersja_xms_2]
mov bajt_1,ah
mov bajt_2,al
end;
write(bajt_1,'.',bajt_2);
end;

{*********************************************************************}
{*Procedura potrzebuje parametru w postaci liczby w zmiennej wielkosc*}
{*        WIELKOSC - ilosc pamieci jaka chcemy zalokowac KB          *}
{*       -=Zwraca parametr w postaci zmiennej DOJSCIE_XMS=-          *}
{*********************************************************************}
procedure xms_zalokuj_blok_emb;
var
slowo:word;
begin
asm
mov ax,seg adres_funkcji_sterujacej
mov es,ax
mov bx,offset adres_funkcji_sterujacej
mov dx,word ptr ds:[wielkosc]
mov ax,900h
call dword ptr es:[bx]
mov slowo,dx
mov blad,bl
end;
sprawdz_blad;
dojscie_xms:=slowo;
end;

procedure xms_zamknij_dojscie_emb;
var
slowo:word;
begin
asm
mov ax,seg adres_funkcji_sterujacej
mov es,ax
mov bx,offset adres_funkcji_sterujacej
mov dx,word ptr ds:[dojscie_xms]
mov ax,0A00h
call dword ptr es:[bx]
mov blad,bl
end;
sprawdz_blad;
end;

procedure przeslij_dane_z_do_xms;
begin
asm
mov ax,seg adres_funkcji_sterujacej
mov es,ax
mov bx,offset adres_funkcji_sterujacej
mov ax,seg dane
mov ds,ax
mov si,offset dane
mov ax,0B00h
call dword ptr es:[bx]
mov blad,bl
end;
sprawdz_blad;
end;

procedure copy_bufor_to_xms;
var
seg_,offs_:word;
begin
dane.bllength:=2000;{ilosc bajtow do przeslania}
asm
mov ax,seg bufor
mov bx,offset bufor
mov seg_,ax
mov offs_,bx
mov word ptr ds:[adres_logiczny+0],bx
mov word ptr ds:[adres_logiczny+2],ax
end;



{*Zrodlo -> adres fizyczny BUFOR-a*}
dane.srchandle:=0;
dane.srcoffset:=adres_logiczny;
{*Cel -> pamiec XMS o offsecie 0*}
dane.dsthandle:=dojscie_xms;
dane.dstoffset:=0;
przeslij_dane_z_do_xms;
end;

procedure copy_xms_to_bufor;
var
seg_,offs_:word;
begin
dane.bllength:=2000;{ilosc bajtow do przeslania}
asm
mov ax,seg bufor
mov bx,offset bufor
mov seg_,ax
mov offs_,bx
mov word ptr ds:[adres_logiczny+0],bx
mov word ptr ds:[adres_logiczny+2],ax
end;
{*Zrodlo -> adres fizyczny BUFOR-a*}
dane.srchandle:=dojscie_xms;
dane.srcoffset:=0;
{*Cel -> pamiec XMS o offsecie 0*}
dane.dsthandle:=0;
dane.dstoffset:=adres_logiczny;
przeslij_dane_z_do_xms;
end;

begin
clrscr;
writeln('Obecnosc XMS: ',xms_obecnosc);
if xms_obecnosc= 'NIE' then
begin
asm
mov ah,4Ch
int 21h
end;
end;
oczysc_bufor;{ <<<------ koniecznosc}
xms_adres_funkcji_sterujacej;
xms_odczytaj_wersje_xms;
write('Numer wersji specyfikacji XMS: ');
xms_pisz_wersje_xms_1;
writeln;
writeln('Wolna pamiec XMS: ',xms_wolna_pamiec_xms,'Kb');
writeln('Najwiekszy wolny blok EMB: ',xms_najwiekszy_wolny_blok_emb,'Kb');
write('Numer wersji programu XMM: ');
xms_pisz_wersje_xms_2;
writeln;
wielkosc:=1024;{1MB pamieci}
xms_zalokuj_blok_emb;
{-----KROTKI TEST POTWIERDZAJACY POPRAWNOSC DZIALANIA PROGRAMU-----}
bufor[1]:=10;
bufor[2]:=20;
bufor[3]:=30;
bufor[4]:=40;
bufor[5]:=50;
bufor[6]:=60;
bufor[166]:=44;
copy_bufor_to_xms;
oczysc_bufor;
copy_xms_to_bufor;
writeln(Bufor[1]);
writeln(Bufor[2]);
writeln(Bufor[3]);
writeln(Bufor[4]);
writeln(Bufor[5]);
writeln(Bufor[6]);
writeln(bufor[166]);
xms_zamknij_dojscie_emb;
end.
